/*

NTC temperature measurement

Si-Tecno Juha Niinikoski 28.11.2002

0.1 deg display added 29.11.2002

*/

//*************************
// NTC measurement scaling
//*************************

/*

Datex 400 series Central Temperature probe, Ysi Mix-B 2252 NTC
2252R @ 25 Deg

10k0 +5V - input
NTC GNG - input



*/


int ntc1_scale(int conv_value)
{

unsigned char idx;

// Converter output pole values
const int ntc_poles[] =
119, 158, 205, 260, 321, 387, 455, 524, 590, 651, 706, 756, 798, 835, 866, 892, 913, 931, 946, 959, 969, 978, 984, 990, 995, 999, 1002, 1005, 1008;


// Temperatures at pole values
const int ntc_temp[] =
-40, -35, -30, -25, -20, -15, -10, -5, 0, 5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 65, 70, 75, 80, 85, 90, 95, 100;

/*
// Multipliers ( *256 ) for pole intervals
const int ntc_mult[] =
33, 27, 23, 21, 19, 19, 19, 19, 21, 23, 26, 30, 35, 41, 49, 59, 71, 86, 104, 126, 138, 208, 219, 264, 315, 376, 448, 532, 512;
*/

// Multipliers ( *320 ) for pole intervals
const int ntc_mult[] =
41, 34, 29, 26, 24, 23, 23, 24, 26, 29, 32, 37, 44, 52, 62, 74, 89, 108, 130, 157, 172, 260, 274, 330, 394, 470, 560, 665, 640;

	if(conv_value < 0)
		conv_value = 0;		// no negative numbers allowed

	idx = 28;
	while (idx != 0 && ntc_poles[idx] > conv_value)
		{
		idx--;
		}

	return (ntc_temp[idx] * 10 + ((conv_value - ntc_poles[idx]) * ntc_mult[idx]) / 32 );
}

