/*

NTC temperature measurement

Si-Tecno Juha Niinikoski 28.11.2002

0.1 deg display added 29.11.2002

*/

//*************************
// NTC measurement scaling
//*************************

/*

Scaling is for BC 3k3 5% NTC type BC 2322 640 63332
R/T Characteristics table 13

NTC +5V - input
10k0 GNG - input



*/


int ntc1_scale(int conv_value)
{

unsigned char idx;

// Converter output pole values
const int ntc_poles[] =
84, 112, 147, 190, 240, 296, 358, 422, 488, 553, 614, 672, 723, 769, 808, 842, 871, 896, 916, 933, 947, 959, 969, 977, 984, 990, 995, 999, 1002;


// Temperatures at pole values
const int ntc_temp[] =
-40, -35, -30, -25, -20, -15, -10, -5, 0, 5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 65, 70, 75, 80, 85, 90, 95, 100;

/*
// Multipliers ( *256 ) for pole intervals
const int ntc_mult[] =
44, 36, 30, 25, 22, 20, 19, 19, 19, 20, 22, 24, 28, 32, 37, 44, 52, 62, 75, 90, 108, 130, 156, 187, 223, 268, 319, 379, 512;
*/

// Multipliers ( *320 ) for pole intervals
const int ntc_mult[] =
56, 45, 37, 32, 28, 26, 24, 24, 24, 25, 28, 31, 35, 40, 46, 55, 65, 78, 93, 112, 135, 163, 195, 234, 279, 336, 399, 474, 640;

	if(conv_value < 0)
		conv_value = 0;		// no negative numbers allowed

	idx = 28;
	while (idx != 0 && ntc_poles[idx] > conv_value)
		{
		idx--;
		}

	return (ntc_temp[idx] * 10 + ((conv_value - ntc_poles[idx]) * ntc_mult[idx]) / 32 );
}

