/*
 *
 * DL430 display / Maken lmpmittari 1.0
 *
 * Juha Niinikoski / Markus Niinikoski 02.09.2003
 *
 * RA5 hardware bug found fron hw design 02.09.2003
 * Project switched to PIC16F818 04.09.2003
 * 2ch measurement & display format 05.09.2003
 * Juusos new characters and in / out text 10.09.2003
 *
 * Different Hardware for Mitsubishi application 31.01.2005
 *
*/


#include <pic.h>
#include "mitsu.h"

/* global variables */

near bit feed_dog;							// watch dog feed flag
near bit s_flag;							// second elapsed
near unsigned char s0;						// second wait counters

static near unsigned char digit_data[3];	// segment bits


/* included programs */

#include "7segmux.c"
#include "adc.c"
//	Select NTC conversion tables
//#include "bc63332.c"
#include "Datex400.c"

/* processor config & id info */


	__CONFIG(UNPROTECT & INTIO & WDTDIS & PWRTEN & BOREN & LVPDIS & MCLRDIS);	// 16F628 & 16F81x

	__IDLOC(0103);							// Device ID

const char id[] = {"Make & Juha Niinikoski 31.01.2005"};	// Visible id string


/* helper routines */


/* watchdog feed routine */


void do_dog( void )
	{
	if(feed_dog)				// wait feed signal
		{				// from IRQ routine
		feed_dog = 0;
		asm("clrwdt");			// make watch dog happy
		}
	}

/* measure, scale & display temperature from chx */

void disp_temp(unsigned char chx)
	{
	int temp;

	temp = 1023 - convert_adc(chx);	// measure CHx  & negate converter reading
	temp = ntc1_scale(temp);	// convert to temperature

	if(temp < -99)
		{
		temp = temp / 10;
		putintdec(temp, 0);
		}	
		else
	putintdec(temp, 1);	// scale to temp
	}



/* main  */

void main(void)
{

//	CMCON = CMCON_INIT;			// comparators off 16F628 only

	OSCCON = OSCCON_INIT;			// select 4MHz clock 16F81x only
	ADCON1 = ADCON1_INIT;			// configure A/D converter 16F81x only
	ADCON0 = ADCON0_INIT;

	PORTB = PORTB_INIT;
	PORTA = PORTA_INIT;

	TRISB = TRISB_INIT;			// RB5 - RB7 otputs
	TRISA = TRISA_INIT;

	init_timers();				// start timing functions
	putst("---");				// start up display
	delayms(2000);

	for(;;)
		{
		do_dog();			// watchdog care

		digit_data[2] = chgen[0x0C];	// print ou
		digit_data[1] = chgen[0x10];
		digit_data[0] = chgen[0x0F];
		delayms(800);
		s0 = 3;
		while(s0 != 0)
			{
			disp_temp(0);		// measure, scale / display ch0
			delayms(100);
			}
		putst("???");			// print blanc
		delayms(500);

		digit_data[2] = chgen[0x0B];	// print in
		digit_data[1] = chgen[0x11];
		digit_data[0] = chgen[0x0F];
		delayms(800);
		s0 = 3;
		while(s0 != 0)
			{
			disp_temp(1);		// measure, scale / display ch1
			delayms(100);
			}
		putst("???");			// print blanc
		delayms(500);
		}
}
