/*
 * Header information for Mitsu temperature meter board
 *
 * Juha Niinikoski 31.1.2005
 * 
 * Project switched to PIC16F818 04.09.2003
 * 
 *
*/

/* Constants and definitions */


/* I/O definitions */

/* Port A */

#define	PORTA_INIT	0
#define TRISA_INIT	0b10101011	// RA2, 4, 6 = digit drive. Note RA5 = input only

#define DIGIT_DRIVE	PORTA		// digit select bits


/* Port B */

#define	PORTB_INIT	0
#define	TRISB_INIT	0x00		// all outputs = segment drive

#define SEGMENT_DRIVE	PORTB		// segment bits


/* Other IO */

//#define CMCON_INIT	0x07		// comparators off 16F628 only

#define OSCCON_INIT	0x60;		// select 4MHz clock 16F81x only

#define	ADCON0_INIT	0b11000001	/* RC osc, CH0 selected */
#define	ADCON1_INIT	0b10000100	/* right justified 3 AD ch, int ref */

//#define	ADCON1_INIT	0x06;		// Test PORTA = I/O bits 16F81x only


/*   Define unsigned data types   */

#ifndef _BYTE_DEFINED_
#define _BYTE_DEFINED_

typedef unsigned char BYTE;
typedef unsigned int WORD;
typedef unsigned long LWORD;

#endif


/*   Define Boolean data type   */

#ifndef _BOOL_DEFINED_
#define _BOOL_DEFINED_

typedef BYTE BOOL;

#define FALSE 0
#define TRUE 1

#endif

/*   Define null pointer   */

#ifndef NULL
#define NULL (void *)0
#endif


